var Messenger;

Messenger = function(){ this.init.apply(this, arguments); };

Messenger.prototype = {
  init: function(target){
    this.target = target;
  }
  , log: function(message){
    var elm = document.createElement('p');
    elm.innerHTML = message;
    this.target.insertBefore(elm, this.target.childNodes[0]);
  }
};

var msgLog = document.getElementById('msg');

var output = new Messenger(msgLog);

output.log("== App is started ==");

//----------------------------------------------------



//translate str to Arrayed buffer
var ab2str =function(buf) {
  return String.fromCharCode.apply(null, new Uint16Array(buf));
};

var str2ab;
str2ab = function(str) {
  var buf = new ArrayBuffer(str.length*2);
  var bufView = new Uint16Array(buf);
  for(var i = 0, l = str.length; i < l; i++) {
    bufView[i] = str.charCodeAt(i);
  }
  console.log(buf);
  return buf;
}

//----------------------------------------------------


var dstAddr = "203.178.139.242"
var dstPort = 38090

var socket = chrome.experimental.socket || chrome.socket;

output.log("ほげほげ")

socket.create("udp", {}, function(createInfo){
  var socketId = createInfo.socketId;
  console.log("socketId is " + socketId);
  output.log("socketId = " + socketId);
  if(socketId < 0){
    socket.destroy(socketId - 3);
    return;
  }
  socket.destroy(socketId -3);
  socket.connect(socketId, dstAddr, dstPort, function(result){
    if(result < 0){
      output.log("client connection error" + result);
      socket.destroy(socketId);
      return;
    }
    output.log("つながりました");

    var input = document.getElementById("sendMsg");
    var submit = document.getElementById("submit");

    submit.addEventListener("click", function(){
      output.log("送ります");
      socket.write(socketId, str2ab(input.value), function(buf){
        if(buf.byteWritten > 0){
          input.value = '';
        }
      });
    }, false);
  });
});

//----------------------------------------------------


var srcAddr = "203.178.139.238"
var srcPort = 38090

var serverSocket = chrome.experimental.socket || chrome.socket;
serverSocket.create("udp", {}, function(serverCreateInfo){
  var serversocketId = serverCreateInfo.socketId;
  console.log("serversocketId is " + serversocketId);
  output.log("serversocketId = " + serversocketId);
  if(serversocketId < 0){
    logger.error("udp create failre " + serverCreateInfo);
    return;
  }

  serverSocket.destroy(serversocketId - 2);
  serverSocket.bind(serversocketId, srcAddr, srcPort, function(result){
    if(result < 0){
      output.log("bind result = " + result);
      serverSocket. destroy(serversocketId);
      return;
    }
    setInterval(function(){
      serverSocket.read(serversocketId, null, function(buf){
        if(buf.resultCode > 0){
            output.log(ab2str(buf.data));
        }
      });
    },1000);
  });
});


